c@a
c@versb
C-----------------------------------------------------------------------
C
CVERS                  Code_Saturne version 1.3
C                      ------------------------
C
C     This file is part of the Code_Saturne Kernel, element of the
C     Code_Saturne CFD tool.
C
C     Copyright (C) 1998-2008 EDF S.A., France
C
C     contact: saturne-support@edf.fr
C
C     The Code_Saturne Kernel is free software; you can redistribute it
C     and/or modify it under the terms of the GNU General Public License
C     as published by the Free Software Foundation; either version 2 of
C     the License, or (at your option) any later version.
C
C     The Code_Saturne Kernel is distributed in the hope that it will be
C     useful, but WITHOUT ANY WARRANTY; without even the implied warranty
C     of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU General Public License for more details.
C
C     You should have received a copy of the GNU General Public License
C     along with the Code_Saturne Kernel; if not, write to the
C     Free Software Foundation, Inc.,
C     51 Franklin St, Fifth Floor,
C     Boston, MA  02110-1301  USA
C
C-----------------------------------------------------------------------
c@verse
                        SUBROUTINE USPROJ
C                       *****************
C     -------------------------------------------------------------
     & ( IDBIA0 , IDBRA0 ,
     &   NDIM   , NCELET , NCEL   , NFAC   , NFABOR , NFML   , NPRFML ,
     &   NNOD   , LNDFAC , LNDFBR , NCELBR ,
     &   NVAR   , NSCAL  , NPHAS  ,
     &   NBPMAX , NVP    , NVEP   , NIVEP  , NTERSL , NVLSTA , NVISBR ,
     &   NIDEVE , NRDEVE , NITUSE , NRTUSE ,
     &   IFACEL , IFABOR , IFMFBR , IFMCEL , IPRFML , MAXELT , LSTELT ,
     &   IPNFAC , NODFAC , IPNFBR , NODFBR , ITEPA  ,
     &   IDEVEL , ITUSER , IA     ,
     &   XYZCEN , SURFAC , SURFBO , CDGFAC , CDGFBO , XYZNOD , VOLUME ,
     &   DT     , RTPA   , RTP    , PROPCE , PROPFA , PROPFB ,
     &   COEFA  , COEFB  ,
     &   ETTP   , ETTPA  , TEPA   , STATIS , STATIV , TSLAGR , PARBOR ,
     &   RDEVEL , RTUSER , RA     )
C     -------------------------------------------------------------
C***********************************************************************
C FONCTION :
C --------
c@foncb
CFONC
CFONC MODIFICATION UTILISATEUR EN FIN DE PAS DE TEMPS
CFONC    TOUT EST POSSIBLE,
CFONC
CFONC
CFONC ON DONNE ICI PLUSIEURS EXEMPLES :
CFONC
CFONC   - CALCUL DE BILAN THERMIQUE
CFONC     (au besoin, voir "ADAPTATION A UN SCALAIRE QUELCONQUE")
CFONC
CFONC   - MODIFICATION ARBITRAIRE D'UNE VARIABLE DE CALCUL
CFONC
CFONC   - EXTRACTION D'UN PROFIL 1D
CFONC
CFONC   - IMPRESSION D'UN MOMENT
CFONC
CFONC   - EXEMPLES D'UTILISATION DES ROUTINES DE PARALLELISME
CFONC
CFONC CES EXEMPLES SONT DONNES EN SUPPOSANT UN CAS AVEC PERIODICITE
CFONC   (IPERIO.GT.0) ET PARALLELISME (IRANGP.GE.0).
CFONC
CFONC
CFONC LE CALCUL DE BILAN THERMIQUE FOURNIT EN OUTRE UNE TRAME POUR
CFONC   PLUSIEURS CHOSES
CFONC   - CALCUL DE GRADIENT (AVEC LES PRECAUTIONS UTILES EN PARALLELE ET
CFONC     PERIODIQUE)
CFONC   - CALCUL DE GRANDEUR DEPENDANT DES VALEURS AUX CELLULES VOISINES
CFONC     D'UNE FACE (AVEC LES PRECAUTIONS A PRENDRE EN PARALLELE ET
CFONC     PERIODIQUE : VOIR L'ECHANGE DE DT ET DE CP)
CFONC   - CALCUL D'UNE SOMME SUR LES PROCESSEURS LORS D'UN CALCUL
CFONC     PARALLELE (PARSOM)
CFONC
CFONC
CFONC IDENTIFICATION DES CELLULES/FACES DE BORD/FACES INTERNES
CFONC ========================================================
CFONC
CFONC   Les commandes GETCEL, GETFBR et GETFAC permettent d'identifier
CFONC   respectivement les cellules, faces ou faces de bord en fonction
CFONC   de differents criteres.
CFONC
CFONC   GETCEL(CHAINE,NLELT,LSTELT) :
CFONC   - CHAINE est une chaine de caractere fournie par l'utilisateur
CFONC     qui donne les criteres de selection
CFONC   - NLTELT est renvoye par la commande. C'est un entier qui
CFONC     correspond au nombre de cellules trouveees repondant au
CFONC     critere
CFONC   - LSTELT est renvoye par la commande. C'est un tableau d'entiers
CFONC     de taille NLTELT donnant la liste des cellules trouvees
CFONC     repondant au critere.
CFONC
CFONC   CHAINE peut etre constitue de :
CFONC   - references de couleurs (ex. : 1, 8, 26, ...
CFONC   - references de groupes (ex. : entrees, groupe1, ...)
CFONC   - criteres geometriques (ex. X<0.1, Y>=0.25, ...)
CFONC   Ces criteres peuvent etre combines par des operateurs logiques
CFONC   (AND et OR) et des parentheses
CFONC   ex. : '1 AND (groupe2 OR groupe3) AND Y<1' permettra de recuperer
CFONC   les cellules de couleur 1, appartenant aux groupes 'groupe2'
CFONC   ou 'groupe3' et de coordonnee Y inferieure a 1.
CFONC
CFONC   La syntaxe des commandes GETFBR et GETFAC est identique.
CFONC
CFONC
c@fonce
C-----------------------------------------------------------------------
C                             ARGUMENTS
c@argub
CARGU .______________.____._____.______________________________________.
CARGU !    NOM       !TYPE!MODE !                   ROLE               !
CARGU !______________!____!_____!______________________________________!
CARGU ! IDBIA0       ! E  !  -> ! NUMERO DE LA 1ERE CASE LIBRE DANS IA !
CARGU ! IDBRA0       ! E  !  -> ! NUMERO DE LA 1ERE CASE LIBRE DANS RA !
CARGU ! NDIM         ! E  !  -> ! DIMENSION DE L'ESPACE                !
CARGU ! NCELET       ! E  !  -> ! NOMBRE D'ELEMENTS HALO COMPRIS       !
CARGU ! NCEL         ! E  !  -> ! NOMBRE D'ELEMENTS ACTIFS             !
CARGU ! NFAC         ! E  !  -> ! NOMBRE DE FACES INTERNES             !
CARGU ! NFABOR       ! E  !  -> ! NOMBRE DE FACES DE BORD              !
CARGU ! NFML         ! E  !  -> ! NOMBRE DE FAMILLES D ENTITES         !
CARGU ! NPRFML       ! E  !  -> ! NOMBRE DE PROPRIETESE DES FAMILLES   !
CARGU ! NNOD         ! E  !  -> ! NOMBRE DE SOMMETS                    !
CARGU ! LNDFAC       ! E  !  -> ! LONGUEUR DU TABLEAU NODFAC (OPTIONNEL!
CARGU ! LNDFBR       ! E  !  -> ! LONGUEUR DU TABLEAU NODFBR (OPTIONNEL!
CARGU ! NCELBR       ! E  !  -> ! NOMBRE D'ELEMENTS AYANT AU MOINS UNE !
CARGU !              !    !     ! FACE DE BORD                         !
CARGU ! NVAR         ! E  !  -> ! NOMBRE TOTAL DE VARIABLES            !
CARGU ! NSCAL        ! E  !  -> ! NOMBRE TOTAL DE SCALAIRES            !
CARGU ! NPHAS        ! E  !  -> ! NOMBRE DE PHASES                     !
CARGU ! NBPMAX       ! E  !  -> ! NOMBRE MAX DE PARTICULES AUTORISE    !
CARGU ! NVP          ! E  !  -> ! NOMBRE DE VARIABLES PARTICULAIRES    !
CARGU ! NVEP         ! E  !  -> ! NOMBRE INFO PARTICULAIRES (REELS)    !
CARGU ! NIVEP        ! E  !  -> ! NOMBRE INFO PARTICULAIRES (ENTIERS)  !
CARGU ! NTERSL       ! E  !  -> ! NBR TERMES SOURCES DE COUPLAGE RETOUR!
CARGU ! NVLSTA       ! E  !  -> ! NOMBRE DE VAR STATISTIQUES LAGRANGIEN!
CARGU ! NVISBR       ! E  !  -> ! NOMBRE DE STATISTIQUES AUX FRONTIERES!
CARGU ! NIDEVE NRDEVE! E  !  -> ! LONGUEUR DE IDEVEL RDEVEL            !
CARGU ! NITUSE NRTUSE! E  !  -> ! LONGUEUR DE ITUSER RTUSER            !
CARGU ! IFACEL       ! TE !  -> ! ELEMENTS VOISINS D'UNE FACE INTERNE  !
CARGU ! (2, NFAC)    !    !     !                                      !
CARGU ! IFABOR       ! TE !  -> ! ELEMENT  VOISIN  D'UNE FACE DE BORD  !
CARGU ! (NFABOR)     !    !     !                                      !
CARGU ! IFMFBR       ! TE !  -> ! NUMERO DE FAMILLE D'UNE FACE DE BORD !
CARGU ! (NFABOR)     !    !     !                                      !
CARGU ! IFMCEL       ! TE !  -> ! NUMERO DE FAMILLE D'UNE CELLULE      !
CARGU ! (NCELET)     !    !     !                                      !
CARGU ! IPRFML       ! TE !  -> ! PROPRIETES D'UNE FAMILLE             !
CARGU ! NFML  ,NPRFML!    !     !                                      !
CARGU ! MAXELT       !  E !  -> ! NB MAX D'ELEMENTS (CELL,FAC,FBR)     !
CARGU ! LSTELT(MAXELT) TE !  -  ! TABLEAU DE TRAVAIL                   !
CARGU ! IPNFAC       ! TE !  -> ! POSITION DU PREMIER NOEUD DE CHAQUE  !
CARGU !   (NFAC+1)   !    !     !  FACE INTERNE DANS NODFAC (OPTIONNEL)!
CARGU ! NODFAC       ! TE !  -> ! CONNECTIVITE FACES INTERNES/NOEUDS   !
CARGU !   (LNDFAC)   !    !     !  (OPTIONNEL)                         !
CARGU ! IPNFBR       ! TE !  -> ! POSITION DU PREMIER NOEUD DE CHAQUE  !
CARGU !  (NFABOR+1)  !    !     !  FACE DE BORD DANS NODFBR (OPTIONNEL)!
CARGU ! NODFBR       ! TE !  -> ! CONNECTIVITE FACES DE BORD/NOEUDS    !
CARGU !   (LNDFBR  ) !    !     !  (OPTIONNEL)                         !
CARGU ! ITEPA        ! TE !  -> ! INFO PARTICULAIRES (ENTIERS)         !
CARGU ! (NBPMAX,NIVEP!    !     !   (CELLULE DE LA PARTICULE,...)      !
CARGU ! IDEVEL(NIDEVE! TE ! <-> ! TAB ENTIER COMPLEMENTAIRE DEVELOPEMT !
CARGU ! ITUSER(NITUSE! TE ! <-> ! TAB ENTIER COMPLEMENTAIRE UTILISATEUR!
CARGU ! IA(*)        ! TR !  -  ! MACRO TABLEAU ENTIER                 !
CARGU ! XYZCEN       ! TR !  -> ! POINT ASSOCIES AUX VOLUMES DE CONTROL!
CARGU ! (NDIM,NCELET !    !     !                                      !
CARGU ! SURFAC       ! TR !  -> ! VECTEUR SURFACE DES FACES INTERNES   !
CARGU ! (NDIM,NFAC)  !    !     !                                      !
CARGU ! SURFBO       ! TR !  -> ! VECTEUR SURFACE DES FACES DE BORD    !
CARGU ! (NDIM,NFABOR)!    !     !                                      !
CARGU ! CDGFAC       ! TR !  -> ! CENTRE DE GRAVITE DES FACES INTERNES !
CARGU ! (NDIM,NFAC)  !    !     !                                      !
CARGU ! CDGFBO       ! TR !  -> ! CENTRE DE GRAVITE DES FACES DE BORD  !
CARGU ! (NDIM,NFABOR)!    !     !                                      !
CARGU ! XYZNOD       ! TR !  -> ! COORDONNES DES NOEUDS (OPTIONNEL)    !
CARGU ! (NDIM,NNOD)  !    !     !                                      !
CARGU ! VOLUME       ! TR !  -> ! VOLUME D'UN DES NCELET ELEMENTS      !
CARGU ! (NCELET      !    !     !                                      !
CARGU ! DT(NCELET)   ! TR !  -> ! PAS DE TEMPS                         !
CARGU ! RTP, RTPA    ! TR !  -> ! VARIABLES DE CALCUL AU CENTRE DES    !
CARGU ! (NCELET,*)   !    !     !    CELLULES (INSTANT COURANT OU PREC)!
CARGU ! PROPCE       ! TR !  -> ! PROPRIETES PHYSIQUES AU CENTRE DES   !
CARGU ! (NCELET,*)   !    !     !    CELLULES                          !
CARGU ! PROPFA       ! TR !  -> ! PROPRIETES PHYSIQUES AU CENTRE DES   !
CARGU !  (NFAC,*)    !    !     !    FACES INTERNES                    !
CARGU ! PROPFB       ! TR !  -> ! PROPRIETES PHYSIQUES AU CENTRE DES   !
CARGU !  (NFABOR,*)  !    !     !    FACES DE BORD                     !
CARGU ! COEFA, COEFB ! TR !  -> ! CONDITIONS AUX LIMITES AUX           !
CARGU !  (NFABOR,*)  !    !     !    FACES DE BORD                     !
CARGU ! ETTP         ! TR !  -> ! TABLEAUX DES VARIABLES LIEES         !
CARGU !  (NBPMAX,NVP)!    !     !   AUX PARTICULES ETAPE COURANTE      !
CARGU ! ETTPA        ! TR !  -> ! TABLEAUX DES VARIABLES LIEES         !
CARGU !  (NBPMAX,NVP)!    !     !   AUX PARTICULES ETAPE PRECEDENTE    !
CARGU ! TEPA         ! TR !  -> ! INFO PARTICULAIRES (REELS)           !
CARGU ! (NBPMAX,NVEP)!    !     !   (POIDS STATISTIQUES,...)           !
CARGU ! STATIS       ! TR !  -> ! MOYENNES STATISTIQUES                !
CARGU !(NCELET,NVLSTA!    !     !                                      !
CARGU ! STATIV       ! TR !  -> ! CUMUL POUR LES VARIANCES DES         !
CARGU !(NCELET,      !    !     !    STATISTIQUES VOLUMIQUES           !
CARGU !   NVLSTA-1)  !    !     !                                      !
CARGU ! TSLAGR       ! TR !  -> ! TERME DE COUPLAGE RETOUR DU          !
CARGU !(NCELET,NTERSL!    !     !   LAGRANGIEN SUR LA PHASE PORTEUSE   !
CARGU ! PARBOR       ! TR !  -> ! INFOS SUR INTERACTION DES PARTICULES !
CARGU !(NFABOR,NVISBR!    !     !   AUX FACES DE BORD                  !
CARGU ! RDEVEL(NRDEVE! TR ! <-> ! TAB REEL COMPLEMENTAIRE DEVELOPEMT   !
CARGU ! RTUSER(NRTUSE! TR ! <-> ! TAB REEL COMPLEMENTAIRE UTILISATEUR  !
CARGU ! RA(*)        ! TR !  -  ! MACRO TABLEAU REEL                   !
CARGU !______________!____!_____!______________________________________!
c@argue
C
c@commb
CCOMM                             COMMONS
CCOMM .______________.____._____.______________________________________.
CCOMM !    NOM       !TYPE!MODE !                   ROLE               !
CCOMM !______________!____!_____!______________________________________!
CCOMM !______________!____!_____!______________________________________!
c@comme
C
C     TYPE : E (ENTIER), R (REEL), A (ALPHANUMERIQUE), T (TABLEAU)
C            L (LOGIQUE)   .. ET TYPES COMPOSES (EX : TR TABLEAU REEL)
C     MODE : -> DONNEE, <- RESULTAT, <-> DONNEE MODIFIEE,
C            - TABLEAU DE TRAVAIL
C***********************************************************************
C


c                        SUBROUTINE DRAGPR
C                       *****************
C     -------------------------------------------------------------
c     & ( IDBIA0 , IDBRA0 , 
c     &   NDIM   , NCELET , NCEL   , NFAC   , NFABOR , NFML   , NPRFML ,
c     &   NNOD   , LNDFAC , LNDFBR , NCELBR , 
c     &   NVAR   , NSCAL  , NPHAS  , 
c     &   NIDEVE , NRDEVE , NITUSE , NRTUSE ,
c     &   IFACEL , IFABOR , IFMFBR , IFMCEL , IPRFML ,
c     &   IPNFAC , NODFAC , IPNFBR , NODFBR ,
c     &   ICOUPL , IDEVEL , ITUSER , IA     , 
c     &   ICOUPL , IDEVEL , ITUSER , ITYPFB , IA     , 
c     &   XYZCEN , SURFAC , SURFBO , CDGFAC , CDGFBO , XYZNOD , VOLUME ,
c     &   DT     , RTPA   , RTP    , PROPCE , PROPFA , PROPFB , 
c     &   COEFA  , COEFB  , 
c     &   RCOUPL , RDEVEL , RTUSER , RA     )


      IMPLICIT NONE
C
C***********************************************************************
C     DONNEES EN COMMON
C***********************************************************************
C
      INCLUDE "dimfbr.h"
      INCLUDE "paramx.h"
      INCLUDE "pointe.h"
      INCLUDE "numvar.h"
      INCLUDE "optcal.h"
      INCLUDE "cstphy.h"
      INCLUDE "cstnum.h"
      INCLUDE "entsor.h"
      INCLUDE "lagpar.h"
      INCLUDE "lagran.h"
      INCLUDE "parall.h"
      INCLUDE "period.h"
      INCLUDE "ppppar.h"
      INCLUDE "ppthch.h"
      INCLUDE "ppincl.h"
C      INCLUDE "sstcas.h"
C
C***********************************************************************
C
C ARGUMENTS
C
      INTEGER          IDBIA0 , IDBRA0
      INTEGER          NDIM   , NCELET , NCEL   , NFAC   , NFABOR
      INTEGER          NFML   , NPRFML
      INTEGER          NNOD   , LNDFAC , LNDFBR , NCELBR
      INTEGER          NVAR   , NSCAL  , NPHAS
      INTEGER          NBPMAX , NVP    , NVEP  , NIVEP
      INTEGER          NTERSL , NVLSTA , NVISBR
      INTEGER          NIDEVE , NRDEVE , NITUSE , NRTUSE
C
      INTEGER          IFACEL(2,NFAC) , IFABOR(NFABOR)
      INTEGER          IFMFBR(NFABOR) , IFMCEL(NCELET)
      INTEGER          IPRFML(NFML,NPRFML)
      INTEGER          MAXELT, LSTELT(MAXELT)
      INTEGER          IPNFAC(NFAC+1), NODFAC(LNDFAC)
      INTEGER          IPNFBR(NFABOR+1), NODFBR(LNDFBR)
      INTEGER          ITEPA(NBPMAX,NIVEP),ITYPFB(NFABOR,NPHAS)
      INTEGER          IDEVEL(NIDEVE), ITUSER(NITUSE)
      INTEGER          IA(*)
C
      DOUBLE PRECISION XYZCEN(NDIM,NCELET)
      DOUBLE PRECISION SURFAC(NDIM,NFAC), SURFBO(NDIM,NFABOR)
      DOUBLE PRECISION CDGFAC(NDIM,NFAC), CDGFBO(NDIM,NFABOR)
      DOUBLE PRECISION XYZNOD(NDIM,NNOD), VOLUME(NCELET)
      DOUBLE PRECISION DT(NCELET), RTP(NCELET,*), RTPA(NCELET,*)
      DOUBLE PRECISION PROPCE(NCELET,*)
      DOUBLE PRECISION PROPFA(NFAC,*), PROPFB(NDIMFB,*)
      DOUBLE PRECISION COEFA(NDIMFB,*), COEFB(NDIMFB,*)
      DOUBLE PRECISION ETTP(NBPMAX,NVP) , ETTPA(NBPMAX,NVP)
      DOUBLE PRECISION TEPA(NBPMAX,NVEP)
      DOUBLE PRECISION STATIS(NCELET,NVLSTA), STATIV(NCELET,NVLSTA-1)
      DOUBLE PRECISION TSLAGR(NCELET,NTERSL)
      DOUBLE PRECISION PARBOR(NFABOR,NVISBR)
      DOUBLE PRECISION RDEVEL(NRDEVE), RTUSER(NRTUSE), RA(*)
C
C VARIABLES LOCALES
C
      INTEGER          IDEBIA, IDEBRA, IFINIA, IFINRA
      INTEGER          IDPDX, IDPDY, IDPDZ, IDPADX, IDPADY, IDPADZ
      INTEGER          ITRAVX, ITRAVY, ITRAVZ
      INTEGER          IVAR, ICLVAR, IDIMTE, ITENSO, INC, ICCOCG
      INTEGER          NSWRGP, IMLIGP, IWARNP, IPHYDP
      INTEGER          ICOUL, IFAC, IEL, ILELT, III, NLELT
      INTEGER          IMOM, IPCMOM, IDTCM, IVARGR
      INTEGER          IREF, IRANGF
      INTEGER          NPTFBR, NPOINT
      INTEGER          IPROF,II ,IPHAS,IUN
C
      DOUBLE PRECISION EPSRGP, CLIMGP, EXTRAP
      DOUBLE PRECISION XYZ(3), DIRDRA(3), DIRLIF(3)
      DOUBLE PRECISION PREF, PREFA
      DOUBLE PRECISION XDRAG, XDRAGA, XLIFT, XLIFTA
      DOUBLE PRECISION DIIPBX, DIIPBY, DIIPBZ
      DOUBLE PRECISION SX, SY, SZ, XX, YY, THET, PIP, PFAC, PFACA
      DOUBLE PRECISION XXCEN, YYCEN
      DOUBLE PRECISION COEFF, THETAF, YDIST
      DOUBLE PRECISION XUA, XVA
      DOUBLE PRECISION XABS, YABS, XU, XV, XUU, XVV, XUV, XK, XEP
      DOUBLE PRECISION XR11, XR22, XR33
C
      CHARACTER*22     NAMFIL
      CHARACTER*2      NAMFBR
      CHARACTER*17     PROFFI
C

C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C    ==========================================
C    Postprocessing in the tandem cylinder case
C    ==========================================
C
C     1. Instantanneous and averaged Drag and Lift
C     2. Profile of Cf and Cp over the two cylinders
C     3. Averaged profiles at given X,Z lines
C
C    (assuming the case is 2D)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C STEP1: We calculate the gradient of the pressure and of the time-averaged pressure
C                  (IDPDX, IDPDY, IDPDZ)      and      (IDPADX, IDPADY,IDPADZ)
C
C     1.1:memory
C     ==========
      IDEBRA = IDBRA0
      IDPDX  = IDEBRA
      IDPDY  = IDPDX +NCELET
      IDPDZ  = IDPDY +NCELET
      IDPADX = IDPDZ +NCELET
      IDPADY = IDPADX+NCELET
      IDPADZ = IDPADY+NCELET
      ITRAVX = IDPADZ+NCELET
      ITRAVY = ITRAVX+NCELET
      ITRAVZ = ITRAVY+NCELET
      IFINRA = ITRAVZ+NCELET
C
      CALL RASIZE('USPROJ',IFINRA)
C
      IVAR = IPR(1)
      ICLVAR = ICLRTP(IVAR,ICOEF)
C
C     1.2:gradient of P
C     =================
C
      IF(IRANGP.GE.0) CALL PARCOM(RTP(1,IVAR))
C
      IF(IPERIO.EQ.1) THEN
        IDIMTE = 0
        ITENSO = 0
        CALL PERCOM
C       ===========
     &  ( NCELET , NCEL   , IDIMTE , ITENSO  ,
     &    RTP(1,IVAR),RTP(1,IVAR),RTP(1,IVAR),
     &    RTP(1,IVAR),RTP(1,IVAR),RTP(1,IVAR),
     &    RTP(1,IVAR),RTP(1,IVAR),RTP(1,IVAR)
     &  )
      ENDIF
C
      INC = 1
      ICCOCG = 1
      NSWRGP = NSWRGR(IVAR)
      IMLIGP = IMLIGR(IVAR)
      IWARNP = IWARNI(IVAR)
      EPSRGP = EPSRGR(IVAR)
      CLIMGP = CLIMGR(IVAR)
      EXTRAP = EXTRAG(IVAR)
      IPHYDP = 0
C
      CALL GRDCEL
C     ===========
     & ( IFINIA , IFINRA ,
     &   NDIM   , NCELET , NCEL   , NFAC   , NFABOR , NFML   , NPRFML ,
     &   NNOD   , LNDFAC , LNDFBR , NCELBR , NPHAS  ,
     &   NIDEVE , NRDEVE , NITUSE , NRTUSE ,
     &   IVAR   , IMRGRA , INC    , ICCOCG , NSWRGP , IMLIGP , IPHYDP ,
     &   IWARNP , NFECRA ,
     &   EPSRGP , CLIMGP , EXTRAP ,
     &   IFACEL , IFABOR , IFMFBR , IFMCEL , IPRFML ,
     &   IPNFAC , NODFAC , IPNFBR , NODFBR ,
     &   IDEVEL , ITUSER , IA     ,
     &   XYZCEN , SURFAC , SURFBO , CDGFAC , CDGFBO , XYZNOD , VOLUME ,
     &   RA(ITRAVX) , RA(ITRAVX) , RA(ITRAVX) ,
     &   RTP(1,IVAR) , COEFA(1,ICLVAR) , COEFB(1,ICLVAR) ,
     &   RA(IDPDX) , RA(IDPDY) , RA(IDPDZ) ,
C        ----------   ----------   ----------
     &   RA(ITRAVX) , RA(ITRAVY) , RA(ITRAVZ) ,
     &   RDEVEL , RTUSER , RA     )
C
C     1.2:gradient of P averaged
C     ==========================
C
      IMOM = 8
      IF(NTCABS.GE.NTDMOM(IMOM))THEN
        IPCMOM = IPPROC(ICMOME(IMOM))
        IDTCM = -IDTMOM(IMOM)
C
        IF(IRANGP.GE.0) CALL PARCOM(PROPCE(1,IPCMOM))
C
        IF(IPERIO.EQ.1) THEN
          IDIMTE = 0
          ITENSO = 0
          CALL PERCOM
C         ===========
     &    ( NCELET , NCEL   , IDIMTE , ITENSO  ,
     &      PROPCE(1,IPCMOM),PROPCE(1,IPCMOM),PROPCE(1,IPCMOM),
     &      PROPCE(1,IPCMOM),PROPCE(1,IPCMOM),PROPCE(1,IPCMOM),
     &      PROPCE(1,IPCMOM),PROPCE(1,IPCMOM),PROPCE(1,IPCMOM)
     &    )
        ENDIF
C
        CALL GRDCEL
C       ===========
     &   ( IFINIA , IFINRA ,
     &     NDIM   , NCELET , NCEL   , NFAC   , NFABOR , NFML   , NPRFML,
     &     NNOD   , LNDFAC , LNDFBR , NCELBR , NPHAS  ,
     &     NIDEVE , NRDEVE , NITUSE , NRTUSE ,
     &     IVAR   , IMRGRA , INC    , ICCOCG , NSWRGP , IMLIGP , IPHYDP,
     &     IWARNP , NFECRA ,
     &     EPSRGP , CLIMGP , EXTRAP ,
     &     IFACEL , IFABOR , IFMFBR , IFMCEL , IPRFML ,
     &     IPNFAC , NODFAC , IPNFBR , NODFBR ,
     &     IDEVEL , ITUSER , IA     ,
     &     XYZCEN , SURFAC , SURFBO , CDGFAC , CDGFBO , XYZNOD , VOLUME,
     &     RA(ITRAVX) , RA(ITRAVX) , RA(ITRAVX) ,
     &     PROPCE(1,IPCMOM) , COEFA(1,ICLVAR) , COEFB(1,ICLVAR) ,
     &     RA(IDPADX) , RA(IDPADY) , RA(IDPADZ) ,
C          ----------   ----------   ----------
     &     RA(ITRAVX) , RA(ITRAVY) , RA(ITRAVZ) ,
     &     RDEVEL , RTUSER , RA     )
C
        DO IEL=1,NCEL
          RA(IDPADX+IEL-1)=RA(IDPADX+IEL-1)/MAX(DTCMOM(IDTCM),EPZERO)
          RA(IDPADY+IEL-1)=RA(IDPADY+IEL-1)/MAX(DTCMOM(IDTCM),EPZERO)
          RA(IDPADZ+IEL-1)=RA(IDPADZ+IEL-1)/MAX(DTCMOM(IDTCM),EPZERO)
        ENDDO
      ELSE
        DO IEL=1,NCEL
          RA(IDPADX+IEL-1)=RA(IDPDX+IEL-1)
          RA(IDPADY+IEL-1)=RA(IDPDY+IEL-1)
          RA(IDPADZ+IEL-1)=RA(IDPDZ+IEL-1)
        ENDDO
      ENDIF

C
C STEP2: We calculate the reference the pressure and of the time-averaged reference pressure
C                  PREF      and      PREFA
      XYZ(1) = -0.4096D0
      XYZ(2) = 0.2867D0
      XYZ(3) = 0.D0
C
      CALL FINDPT
C     ===========
     & (NCELET, NCEL, XYZCEN,
     &  XYZ(1), XYZ(2), XYZ(3), IREF, IRANGF)
C
      PREF  = 0.D0
      PREFA = 0.D0

      IF(IRANGP.EQ.IRANGF)THEN
        IMOM = 8
        IF(NTCABS.GE.NTDMOM(IMOM))THEN
          IPCMOM = IPPROC(ICMOME(IMOM))
          IDTCM = -IDTMOM(IMOM)
          PREFA = PROPCE(IREF,IPCMOM)/
     &           MAX(DTCMOM(IDTCM),EPZERO)
        ELSE
          PREFA = RTP(IREF,IPR(1))
        ENDIF
        PREF = RTP(IREF,IPR(1))
      ENDIF
      IF(IRANGP.GE.0) THEN
        CALL PARBCR(IRANGF,1,PREF)
        CALL PARBCR(IRANGF,1,PREFA)
      ENDIF
C
C STEP3: We calculate drag, lift, pressure and skin-friction coefficient (for the front and rear cylinder) 
C
      DIRDRA(1)=1.D0
      DIRDRA(2)=0.D0
      DIRDRA(3)=0.D0
      DIRLIF(1)=0.D0
      DIRLIF(2)=1.D0
      DIRLIF(3)=0.D0
C
      DO ICOUL=11,12
C
        WRITE(NAMFIL,'(A11,I2,A1,I2.2,A4)') "CpCf_Cylinder",
     &                                    ICOUL,"_",IRANGP,".dat"
        IF(NTCABS.EQ.NTMABS) THEN
          OPEN(UNIT=IMPUSR(1),FILE=NAMFIL)  
        ENDIF 
C
        IF(ICOUL.EQ.11) THEN
          XXCEN=0.D0
          YYCEN=0.D0
        ELSEIF(ICOUL.EQ.12) THEN
          XXCEN=3.7D0
          YYCEN=0.D0
        ENDIF
C
        NPTFBR = 0
        XDRAG  = 0.D0
        XDRAGA = 0.D0
        XLIFT  = 0.D0
        XLIFTA = 0.D0
C
        WRITE(NAMFBR,'(I2)') ICOUL
        CALL GETFBR(NAMFBR,NLELT,LSTELT)
C       ===========
        DO ILELT = 1, NLELT
C
          NPTFBR = NPTFBR + 1
          IFAC = LSTELT(ILELT)
          IEL  = IFABOR(IFAC)
          III = IDIIPB-1+3*(IFAC-1)
          DIIPBX = RA(III+1)
          DIIPBY = RA(III+2)
          DIIPBZ = RA(III+3)
          SX = SURFBO(1,IFAC)
          SY = SURFBO(2,IFAC)
          SZ = SURFBO(3,IFAC)
C
          XX = (CDGFBO(1,IFAC)-XXCEN)
          YY = (CDGFBO(2,IFAC)-YYCEN)
          THET = ATAN(ABS(YY/XX))/PI*180.D0
          IF(XX.GT.0.D0.AND.YY.GT.0.D0) THET = 180.0-THET
          IF(XX.GT.0.D0.AND.YY.LT.0.D0) THET = 180.0+THET
          IF(XX.LT.0.D0.AND.YY.LT.0.D0) THET = 360.0-THET
C
C         instantaneous quantities
          PIP = RTP(IEL,IPR(1))
          PFAC = PIP + 
     &               + RA(IDPDX+IEL-1)*DIIPBX
     &               + RA(IDPDY+IEL-1)*DIIPBY
     &               + RA(IDPDZ+IEL-1)*DIIPBZ
C
          XDRAG = XDRAG+PFAC*(SX*DIRDRA(1)+SY*DIRDRA(2)+SZ*DIRDRA(3))
          XLIFT = XLIFT+PFAC*(SX*DIRLIF(1)+SY*DIRLIF(2)+SZ*DIRLIF(3))
C
C         time averaged quantities
          IMOM = 8
          IF(NTCABS.GE.NTDMOM(IMOM))THEN
            IPCMOM = IPPROC(ICMOME(IMOM))
            IDTCM = -IDTMOM(IMOM)
            PIP = PROPCE(IEL,IPCMOM)/MAX(DTCMOM(IDTCM),EPZERO)
          ELSE
            PIP = RTP(IEL,IPR(1))
          ENDIF            
C
          PFACA = PIP + 
     &                + RA(IDPADX+IEL-1)*DIIPBX
     &                + RA(IDPADY+IEL-1)*DIIPBY
     &                + RA(IDPADZ+IEL-1)*DIIPBZ
C
          XDRAGA=XDRAGA+PFACA*(SX*DIRDRA(1)+SY*DIRDRA(2)+SZ*DIRDRA(3))
          XLIFTA=XLIFTA+PFACA*(SX*DIRLIF(1)+SY*DIRLIF(2)+SZ*DIRLIF(3))
C
C         skin-friction coefficient
          IMOM = 1
          IF(NTCABS.GE.NTDMOM(IMOM))THEN
            IPCMOM = IPPROC(ICMOME(IMOM))
            IDTCM = -IDTMOM(IMOM)
            XUA = PROPCE(IEL,IPCMOM)/
     &             MAX(DTCMOM(IDTCM),EPZERO)
          ELSE
            XUA = RTP(IEL,IU(1))
          ENDIF
          IMOM = 2
          IF(NTCABS.GE.NTDMOM(IMOM))THEN
            IPCMOM = IPPROC(ICMOME(IMOM))
            IDTCM = -IDTMOM(IMOM)
            XVA = PROPCE(IEL,IPCMOM)/
     &             MAX(DTCMOM(IDTCM),EPZERO)
          ELSE
            XVA = RTP(IEL,IV(1))
          ENDIF

          THETAF = ATAN(YY/XX)
          YDIST=SQRT(DIIPBX**2.+DIIPBY**2.+DIIPBZ**2.)
C
          COEFF = VISCL0(1)*
     &    (SIN(THETAF)*XUA-COS(THETAF)*XVA)
     &         /(YDIST*0.5D0*RO0(1)*UREF(1)**2)
          IF(SIN(THETAF).LE.0.D0) COEFF=-COEFF

C
          IF(NTCABS.EQ.NTMABS) THEN
            WRITE(IMPUSR(1),*) THET, -(PFACA-PREFA)/(0.5D0*UREF(1)**2),
     &                   COEFF
          ENDIF                
C
        ENDDO
C
        IF(IRANGP.GE.0) THEN
          CALL PARSOM(XDRAG)
          CALL PARSOM(XDRAGA)
          CALL PARSOM(XLIFT)
          CALL PARSOM(XLIFTA) 
          CALL PARCPT(NPTFBR)
        ENDIF
        XDRAG =XDRAG /5.D1              
        XDRAGA=XDRAGA/5.D1              
        XLIFT =XLIFT /5.D1              
        XLIFTA=XLIFTA/5.D1              
C
        IF(IRANGP.LE.0) THEN
          WRITE(NFECRA,*) "Drag COUL,T,Drag,Draga",
     &             ICOUL,DTREF*NTCABS, XDRAG,XDRAGA
          WRITE(NFECRA,*) "Lift COUL,T,Lift,Lifta",
     &             ICOUL,DTREF*NTCABS, XDRAG,XDRAGA
        ENDIF
C
        IF(NTCABS.EQ.NTMABS) THEN
          CLOSE(UNIT=IMPUSR(1))  
        ENDIF
C
      ENDDO
C
      RETURN
      END
c@z
